/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2013-07-23 14:19:34,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.rest.model;

/**
 * A Content Item definition, including all data needed to properly
 * access the item, and understand the item.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
@javax.xml.bind.annotation.XmlType( name = "content-list-resource" )
@javax.xml.bind.annotation.XmlAccessorType(javax.xml.bind.annotation.XmlAccessType.FIELD)
public class ContentListResource
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The URI that can be used to directly access this item in the
     * future.
     */
    private String resourceURI;

    /**
     * The relative path in relation to the root of the repository.
     */
    private String relativePath;

    /**
     * A name of the content item.
     */
    private String text;

    /**
     * A (possibly longer) description of the content item.
     */
    private String description;

    /**
     * Flag that states whether the content item is a file item (if
     * true), otherwise it is a folder item, and can use the
     * resourceURI to retrieve the contained content.
     */
    private boolean leaf = false;

    /**
     * Timestamp the item was last modified.
     */
    private java.util.Date lastModified;

    /**
     * Size of the item on the disk.
     */
    private long sizeOnDisk = 0L;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Get a (possibly longer) description of the content item.
     * 
     * @return String
     */
    public String getDescription()
    {
        return this.description;
    } //-- String getDescription()

    /**
     * Get timestamp the item was last modified.
     * 
     * @return Date
     */
    public java.util.Date getLastModified()
    {
        return this.lastModified;
    } //-- java.util.Date getLastModified()

    /**
     * Get the relative path in relation to the root of the
     * repository.
     * 
     * @return String
     */
    public String getRelativePath()
    {
        return this.relativePath;
    } //-- String getRelativePath()

    /**
     * Get the URI that can be used to directly access this item in
     * the future.
     * 
     * @return String
     */
    public String getResourceURI()
    {
        return this.resourceURI;
    } //-- String getResourceURI()

    /**
     * Get size of the item on the disk.
     * 
     * @return long
     */
    public long getSizeOnDisk()
    {
        return this.sizeOnDisk;
    } //-- long getSizeOnDisk()

    /**
     * Get a name of the content item.
     * 
     * @return String
     */
    public String getText()
    {
        return this.text;
    } //-- String getText()

    /**
     * Get flag that states whether the content item is a file item
     * (if true), otherwise it is a folder item, and can use the
     * resourceURI to retrieve the contained content.
     * 
     * @return boolean
     */
    public boolean isLeaf()
    {
        return this.leaf;
    } //-- boolean isLeaf()

    /**
     * Set a (possibly longer) description of the content item.
     * 
     * @param description
     */
    public void setDescription( String description )
    {
        this.description = description;
    } //-- void setDescription( String )

    /**
     * Set timestamp the item was last modified.
     * 
     * @param lastModified
     */
    public void setLastModified( java.util.Date lastModified )
    {
        this.lastModified = lastModified;
    } //-- void setLastModified( java.util.Date )

    /**
     * Set flag that states whether the content item is a file item
     * (if true), otherwise it is a folder item, and can use the
     * resourceURI to retrieve the contained content.
     * 
     * @param leaf
     */
    public void setLeaf( boolean leaf )
    {
        this.leaf = leaf;
    } //-- void setLeaf( boolean )

    /**
     * Set the relative path in relation to the root of the
     * repository.
     * 
     * @param relativePath
     */
    public void setRelativePath( String relativePath )
    {
        this.relativePath = relativePath;
    } //-- void setRelativePath( String )

    /**
     * Set the URI that can be used to directly access this item in
     * the future.
     * 
     * @param resourceURI
     */
    public void setResourceURI( String resourceURI )
    {
        this.resourceURI = resourceURI;
    } //-- void setResourceURI( String )

    /**
     * Set size of the item on the disk.
     * 
     * @param sizeOnDisk
     */
    public void setSizeOnDisk( long sizeOnDisk )
    {
        this.sizeOnDisk = sizeOnDisk;
    } //-- void setSizeOnDisk( long )

    /**
     * Set a name of the content item.
     * 
     * @param text
     */
    public void setText( String text )
    {
        this.text = text;
    } //-- void setText( String )

}
