/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2013-07-23 14:19:34,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.rest.model;

/**
 * List of all global configuration items in Nexus.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
@javax.xml.bind.annotation.XmlType( name = "global-settings-item" )
@javax.xml.bind.annotation.XmlAccessorType(javax.xml.bind.annotation.XmlAccessType.FIELD)
public class GlobalConfigurationResource
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Flag that determines if security is enabled, if false, there
     * will be no authc/authz checks performed on any requests to
     * the systme.
     */
    private boolean securityEnabled = false;

    /**
     * Flag that, if true, will allow anonymous access while
     * security is enabled.
     */
    private boolean securityAnonymousAccessEnabled = false;

    /**
     * The username to use for anonymous access (so that
     * roles/privileges can be applied to the anonymous access
     * users).
     */
    private String securityAnonymousUsername;

    /**
     * The password to use for anonymous access.
     */
    private String securityAnonymousPassword;

    /**
     * Field securityRealms.
     */
    @javax.xml.bind.annotation.XmlElementWrapper( name = "securityRealms" )
    @javax.xml.bind.annotation.XmlElement( name = "securityRealmItem" )
    private java.util.List<String> securityRealms;

    /**
     * Global remote connection settings.
     */
    private RemoteConnectionSettings globalConnectionSettings;

    /**
     * System notification settings.
     */
    private SystemNotificationSettings systemNotificationSettings;

    /**
     * SMTP settings for email notifications that Nexus generates.
     */
    private SmtpSettings smtpSettings;

    /**
     * Remote Proxy Settings.
     */
    private RemoteProxySettingsDTO remoteProxySettings;

    /**
     * Rest API configuration parameters.
     */
    private RestApiSettings globalRestApiSettings;

    /**
     * Error reporting configuration parameters.
     */
    private ErrorReportingSettings errorReportingSettings;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addSecurityRealm.
     * 
     * @param string
     */
    public void addSecurityRealm( String string )
    {
        getSecurityRealms().add( string );
    } //-- void addSecurityRealm( String )

    /**
     * Get error reporting configuration parameters.
     * 
     * @return ErrorReportingSettings
     */
    public ErrorReportingSettings getErrorReportingSettings()
    {
        return this.errorReportingSettings;
    } //-- ErrorReportingSettings getErrorReportingSettings()

    /**
     * Get global remote connection settings.
     * 
     * @return RemoteConnectionSettings
     */
    public RemoteConnectionSettings getGlobalConnectionSettings()
    {
        return this.globalConnectionSettings;
    } //-- RemoteConnectionSettings getGlobalConnectionSettings()

    /**
     * Get rest API configuration parameters.
     * 
     * @return RestApiSettings
     */
    public RestApiSettings getGlobalRestApiSettings()
    {
        return this.globalRestApiSettings;
    } //-- RestApiSettings getGlobalRestApiSettings()

    /**
     * Get remote Proxy Settings.
     * 
     * @return RemoteProxySettingsDTO
     */
    public RemoteProxySettingsDTO getRemoteProxySettings()
    {
        return this.remoteProxySettings;
    } //-- RemoteProxySettingsDTO getRemoteProxySettings()

    /**
     * Get the password to use for anonymous access.
     * 
     * @return String
     */
    public String getSecurityAnonymousPassword()
    {
        return this.securityAnonymousPassword;
    } //-- String getSecurityAnonymousPassword()

    /**
     * Get the username to use for anonymous access (so that
     * roles/privileges can be applied to the anonymous access
     * users).
     * 
     * @return String
     */
    public String getSecurityAnonymousUsername()
    {
        return this.securityAnonymousUsername;
    } //-- String getSecurityAnonymousUsername()

    /**
     * Method getSecurityRealms.
     * 
     * @return List
     */
    public java.util.List<String> getSecurityRealms()
    {
        if ( this.securityRealms == null )
        {
            this.securityRealms = new java.util.ArrayList<String>();
        }

        return this.securityRealms;
    } //-- java.util.List<String> getSecurityRealms()

    /**
     * Get sMTP settings for email notifications that Nexus
     * generates.
     * 
     * @return SmtpSettings
     */
    public SmtpSettings getSmtpSettings()
    {
        return this.smtpSettings;
    } //-- SmtpSettings getSmtpSettings()

    /**
     * Get system notification settings.
     * 
     * @return SystemNotificationSettings
     */
    public SystemNotificationSettings getSystemNotificationSettings()
    {
        return this.systemNotificationSettings;
    } //-- SystemNotificationSettings getSystemNotificationSettings()

    /**
     * Get flag that, if true, will allow anonymous access while
     * security is enabled.
     * 
     * @return boolean
     */
    public boolean isSecurityAnonymousAccessEnabled()
    {
        return this.securityAnonymousAccessEnabled;
    } //-- boolean isSecurityAnonymousAccessEnabled()

    /**
     * Get flag that determines if security is enabled, if false,
     * there will be no authc/authz checks performed on any
     * requests to the systme.
     * 
     * @return boolean
     */
    public boolean isSecurityEnabled()
    {
        return this.securityEnabled;
    } //-- boolean isSecurityEnabled()

    /**
     * Method removeSecurityRealm.
     * 
     * @param string
     */
    public void removeSecurityRealm( String string )
    {
        getSecurityRealms().remove( string );
    } //-- void removeSecurityRealm( String )

    /**
     * Set error reporting configuration parameters.
     * 
     * @param errorReportingSettings
     */
    public void setErrorReportingSettings( ErrorReportingSettings errorReportingSettings )
    {
        this.errorReportingSettings = errorReportingSettings;
    } //-- void setErrorReportingSettings( ErrorReportingSettings )

    /**
     * Set global remote connection settings.
     * 
     * @param globalConnectionSettings
     */
    public void setGlobalConnectionSettings( RemoteConnectionSettings globalConnectionSettings )
    {
        this.globalConnectionSettings = globalConnectionSettings;
    } //-- void setGlobalConnectionSettings( RemoteConnectionSettings )

    /**
     * Set rest API configuration parameters.
     * 
     * @param globalRestApiSettings
     */
    public void setGlobalRestApiSettings( RestApiSettings globalRestApiSettings )
    {
        this.globalRestApiSettings = globalRestApiSettings;
    } //-- void setGlobalRestApiSettings( RestApiSettings )

    /**
     * Set remote Proxy Settings.
     * 
     * @param remoteProxySettings
     */
    public void setRemoteProxySettings( RemoteProxySettingsDTO remoteProxySettings )
    {
        this.remoteProxySettings = remoteProxySettings;
    } //-- void setRemoteProxySettings( RemoteProxySettingsDTO )

    /**
     * Set flag that, if true, will allow anonymous access while
     * security is enabled.
     * 
     * @param securityAnonymousAccessEnabled
     */
    public void setSecurityAnonymousAccessEnabled( boolean securityAnonymousAccessEnabled )
    {
        this.securityAnonymousAccessEnabled = securityAnonymousAccessEnabled;
    } //-- void setSecurityAnonymousAccessEnabled( boolean )

    /**
     * Set the password to use for anonymous access.
     * 
     * @param securityAnonymousPassword
     */
    public void setSecurityAnonymousPassword( String securityAnonymousPassword )
    {
        this.securityAnonymousPassword = securityAnonymousPassword;
    } //-- void setSecurityAnonymousPassword( String )

    /**
     * Set the username to use for anonymous access (so that
     * roles/privileges can be applied to the anonymous access
     * users).
     * 
     * @param securityAnonymousUsername
     */
    public void setSecurityAnonymousUsername( String securityAnonymousUsername )
    {
        this.securityAnonymousUsername = securityAnonymousUsername;
    } //-- void setSecurityAnonymousUsername( String )

    /**
     * Set flag that determines if security is enabled, if false,
     * there will be no authc/authz checks performed on any
     * requests to the systme.
     * 
     * @param securityEnabled
     */
    public void setSecurityEnabled( boolean securityEnabled )
    {
        this.securityEnabled = securityEnabled;
    } //-- void setSecurityEnabled( boolean )

    /**
     * Set list of security realms that are enabled for Nexus, note
     * that order IS important.
     * 
     * @param securityRealms
     */
    public void setSecurityRealms( java.util.List<String> securityRealms )
    {
        this.securityRealms = securityRealms;
    } //-- void setSecurityRealms( java.util.List )

    /**
     * Set sMTP settings for email notifications that Nexus
     * generates.
     * 
     * @param smtpSettings
     */
    public void setSmtpSettings( SmtpSettings smtpSettings )
    {
        this.smtpSettings = smtpSettings;
    } //-- void setSmtpSettings( SmtpSettings )

    /**
     * Set system notification settings.
     * 
     * @param systemNotificationSettings
     */
    public void setSystemNotificationSettings( SystemNotificationSettings systemNotificationSettings )
    {
        this.systemNotificationSettings = systemNotificationSettings;
    } //-- void setSystemNotificationSettings( SystemNotificationSettings )

}
