/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2013-07-23 14:19:34,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.rest.model;

/**
 * Repository general details.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
@javax.xml.bind.annotation.XmlType( name = "repositories-item" )
@javax.xml.bind.annotation.XmlAccessorType(javax.xml.bind.annotation.XmlAccessType.FIELD)
public class RepositoryListResource
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * URI used to manage the repository.
     */
    private String resourceURI;

    /**
     * URI used to access repository over /content URL (as maven
     * would do for example).
     */
    private String contentResourceURI;

    /**
     * The id of the repository.
     */
    private String id;

    /**
     * The name of the repository.
     */
    private String name;

    /**
     * The type of the repository.
     */
    private String repoType;

    /**
     * The policy of the repository.
     */
    private String repoPolicy;

    /**
     * The repository provider.
     */
    private String provider;

    /**
     * The role of the repository (classname).
     */
    private String providerRole;

    /**
     * The format of the repository.
     */
    private String format;

    /**
     * Flag that states if the repository is manageable by the user.
     */
    private boolean userManaged = false;

    /**
     * Flag that states if the repository is exposed over the
     * content url.
     */
    private boolean exposed = true;

    /**
     * The URL where the repository storage is on server.
     */
    private String effectiveLocalStorageUrl;

    /**
     * The remote URI of the repository.
     */
    private String remoteUri;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Get uRI used to access repository over /content URL (as
     * maven would do for example).
     * 
     * @return String
     */
    public String getContentResourceURI()
    {
        return this.contentResourceURI;
    } //-- String getContentResourceURI()

    /**
     * Get the URL where the repository storage is on server.
     * 
     * @return String
     */
    public String getEffectiveLocalStorageUrl()
    {
        return this.effectiveLocalStorageUrl;
    } //-- String getEffectiveLocalStorageUrl()

    /**
     * Get the format of the repository.
     * 
     * @return String
     */
    public String getFormat()
    {
        return this.format;
    } //-- String getFormat()

    /**
     * Get the id of the repository.
     * 
     * @return String
     */
    public String getId()
    {
        return this.id;
    } //-- String getId()

    /**
     * Get the name of the repository.
     * 
     * @return String
     */
    public String getName()
    {
        return this.name;
    } //-- String getName()

    /**
     * Get the repository provider.
     * 
     * @return String
     */
    public String getProvider()
    {
        return this.provider;
    } //-- String getProvider()

    /**
     * Get the role of the repository (classname).
     * 
     * @return String
     */
    public String getProviderRole()
    {
        return this.providerRole;
    } //-- String getProviderRole()

    /**
     * Get the remote URI of the repository.
     * 
     * @return String
     */
    public String getRemoteUri()
    {
        return this.remoteUri;
    } //-- String getRemoteUri()

    /**
     * Get the policy of the repository.
     * 
     * @return String
     */
    public String getRepoPolicy()
    {
        return this.repoPolicy;
    } //-- String getRepoPolicy()

    /**
     * Get the type of the repository.
     * 
     * @return String
     */
    public String getRepoType()
    {
        return this.repoType;
    } //-- String getRepoType()

    /**
     * Get uRI used to manage the repository.
     * 
     * @return String
     */
    public String getResourceURI()
    {
        return this.resourceURI;
    } //-- String getResourceURI()

    /**
     * Get flag that states if the repository is exposed over the
     * content url.
     * 
     * @return boolean
     */
    public boolean isExposed()
    {
        return this.exposed;
    } //-- boolean isExposed()

    /**
     * Get flag that states if the repository is manageable by the
     * user.
     * 
     * @return boolean
     */
    public boolean isUserManaged()
    {
        return this.userManaged;
    } //-- boolean isUserManaged()

    /**
     * Set uRI used to access repository over /content URL (as
     * maven would do for example).
     * 
     * @param contentResourceURI
     */
    public void setContentResourceURI( String contentResourceURI )
    {
        this.contentResourceURI = contentResourceURI;
    } //-- void setContentResourceURI( String )

    /**
     * Set the URL where the repository storage is on server.
     * 
     * @param effectiveLocalStorageUrl
     */
    public void setEffectiveLocalStorageUrl( String effectiveLocalStorageUrl )
    {
        this.effectiveLocalStorageUrl = effectiveLocalStorageUrl;
    } //-- void setEffectiveLocalStorageUrl( String )

    /**
     * Set flag that states if the repository is exposed over the
     * content url.
     * 
     * @param exposed
     */
    public void setExposed( boolean exposed )
    {
        this.exposed = exposed;
    } //-- void setExposed( boolean )

    /**
     * Set the format of the repository.
     * 
     * @param format
     */
    public void setFormat( String format )
    {
        this.format = format;
    } //-- void setFormat( String )

    /**
     * Set the id of the repository.
     * 
     * @param id
     */
    public void setId( String id )
    {
        this.id = id;
    } //-- void setId( String )

    /**
     * Set the name of the repository.
     * 
     * @param name
     */
    public void setName( String name )
    {
        this.name = name;
    } //-- void setName( String )

    /**
     * Set the repository provider.
     * 
     * @param provider
     */
    public void setProvider( String provider )
    {
        this.provider = provider;
    } //-- void setProvider( String )

    /**
     * Set the role of the repository (classname).
     * 
     * @param providerRole
     */
    public void setProviderRole( String providerRole )
    {
        this.providerRole = providerRole;
    } //-- void setProviderRole( String )

    /**
     * Set the remote URI of the repository.
     * 
     * @param remoteUri
     */
    public void setRemoteUri( String remoteUri )
    {
        this.remoteUri = remoteUri;
    } //-- void setRemoteUri( String )

    /**
     * Set the policy of the repository.
     * 
     * @param repoPolicy
     */
    public void setRepoPolicy( String repoPolicy )
    {
        this.repoPolicy = repoPolicy;
    } //-- void setRepoPolicy( String )

    /**
     * Set the type of the repository.
     * 
     * @param repoType
     */
    public void setRepoType( String repoType )
    {
        this.repoType = repoType;
    } //-- void setRepoType( String )

    /**
     * Set uRI used to manage the repository.
     * 
     * @param resourceURI
     */
    public void setResourceURI( String resourceURI )
    {
        this.resourceURI = resourceURI;
    } //-- void setResourceURI( String )

    /**
     * Set flag that states if the repository is manageable by the
     * user.
     * 
     * @param userManaged
     */
    public void setUserManaged( boolean userManaged )
    {
        this.userManaged = userManaged;
    } //-- void setUserManaged( boolean )

}
