/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2013-07-23 14:19:34,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.rest.model;

/**
 * Hosted or Proxy repository parameters, extending the base
 * resource.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
@javax.xml.bind.annotation.XmlType( name = "hosted-repository" )
@javax.xml.bind.annotation.XmlAccessorType(javax.xml.bind.annotation.XmlAccessType.FIELD)
public class RepositoryResource
    extends RepositoryBaseResource
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Write policy on the repository, allows for no write, write
     * once, overwrite, etc.
     */
    private String writePolicy;

    /**
     * Flag that states if the repository is browseable.
     */
    private boolean browseable = false;

    /**
     * Flag that states if the repository is indexable.
     */
    private boolean indexable = false;

    /**
     * How long requests should remain in the NFC before checking
     * for existance again.
     */
    private int notFoundCacheTTL = 0;

    /**
     * The repository policy (release, snapshot).
     */
    private String repoPolicy;

    /**
     * The repository checksum policy (ignore checksum errors, dont
     * download if checksum errors, etc.).
     */
    private String checksumPolicy;

    /**
     * Flag that states if the proxy repository should download
     * indexes from remote repository.
     */
    private boolean downloadRemoteIndexes = false;

    /**
     * User defined storage directory on server (which is not the
     * default).
     */
    private String overrideLocalStorageUrl;

    /**
     * The default storage directory on the server.
     */
    private String defaultLocalStorageUrl;

    /**
     * The remote storage details.
     */
    private RepositoryResourceRemoteStorage remoteStorage;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Get the repository checksum policy (ignore checksum errors,
     * dont download if checksum errors, etc.).
     * 
     * @return String
     */
    public String getChecksumPolicy()
    {
        return this.checksumPolicy;
    } //-- String getChecksumPolicy()

    /**
     * Get the default storage directory on the server.
     * 
     * @return String
     */
    public String getDefaultLocalStorageUrl()
    {
        return this.defaultLocalStorageUrl;
    } //-- String getDefaultLocalStorageUrl()

    /**
     * Get how long requests should remain in the NFC before
     * checking for existance again.
     * 
     * @return int
     */
    public int getNotFoundCacheTTL()
    {
        return this.notFoundCacheTTL;
    } //-- int getNotFoundCacheTTL()

    /**
     * Get user defined storage directory on server (which is not
     * the default).
     * 
     * @return String
     */
    public String getOverrideLocalStorageUrl()
    {
        return this.overrideLocalStorageUrl;
    } //-- String getOverrideLocalStorageUrl()

    /**
     * Get the remote storage details.
     * 
     * @return RepositoryResourceRemoteStorage
     */
    public RepositoryResourceRemoteStorage getRemoteStorage()
    {
        return this.remoteStorage;
    } //-- RepositoryResourceRemoteStorage getRemoteStorage()

    /**
     * Get the repository policy (release, snapshot).
     * 
     * @return String
     */
    public String getRepoPolicy()
    {
        return this.repoPolicy;
    } //-- String getRepoPolicy()

    /**
     * Get write policy on the repository, allows for no write,
     * write once, overwrite, etc.
     * 
     * @return String
     */
    public String getWritePolicy()
    {
        return this.writePolicy;
    } //-- String getWritePolicy()

    /**
     * Get flag that states if the repository is browseable.
     * 
     * @return boolean
     */
    public boolean isBrowseable()
    {
        return this.browseable;
    } //-- boolean isBrowseable()

    /**
     * Get flag that states if the proxy repository should download
     * indexes from remote repository.
     * 
     * @return boolean
     */
    public boolean isDownloadRemoteIndexes()
    {
        return this.downloadRemoteIndexes;
    } //-- boolean isDownloadRemoteIndexes()

    /**
     * Get flag that states if the repository is indexable.
     * 
     * @return boolean
     */
    public boolean isIndexable()
    {
        return this.indexable;
    } //-- boolean isIndexable()

    /**
     * Set flag that states if the repository is browseable.
     * 
     * @param browseable
     */
    public void setBrowseable( boolean browseable )
    {
        this.browseable = browseable;
    } //-- void setBrowseable( boolean )

    /**
     * Set the repository checksum policy (ignore checksum errors,
     * dont download if checksum errors, etc.).
     * 
     * @param checksumPolicy
     */
    public void setChecksumPolicy( String checksumPolicy )
    {
        this.checksumPolicy = checksumPolicy;
    } //-- void setChecksumPolicy( String )

    /**
     * Set the default storage directory on the server.
     * 
     * @param defaultLocalStorageUrl
     */
    public void setDefaultLocalStorageUrl( String defaultLocalStorageUrl )
    {
        this.defaultLocalStorageUrl = defaultLocalStorageUrl;
    } //-- void setDefaultLocalStorageUrl( String )

    /**
     * Set flag that states if the proxy repository should download
     * indexes from remote repository.
     * 
     * @param downloadRemoteIndexes
     */
    public void setDownloadRemoteIndexes( boolean downloadRemoteIndexes )
    {
        this.downloadRemoteIndexes = downloadRemoteIndexes;
    } //-- void setDownloadRemoteIndexes( boolean )

    /**
     * Set flag that states if the repository is indexable.
     * 
     * @param indexable
     */
    public void setIndexable( boolean indexable )
    {
        this.indexable = indexable;
    } //-- void setIndexable( boolean )

    /**
     * Set how long requests should remain in the NFC before
     * checking for existance again.
     * 
     * @param notFoundCacheTTL
     */
    public void setNotFoundCacheTTL( int notFoundCacheTTL )
    {
        this.notFoundCacheTTL = notFoundCacheTTL;
    } //-- void setNotFoundCacheTTL( int )

    /**
     * Set user defined storage directory on server (which is not
     * the default).
     * 
     * @param overrideLocalStorageUrl
     */
    public void setOverrideLocalStorageUrl( String overrideLocalStorageUrl )
    {
        this.overrideLocalStorageUrl = overrideLocalStorageUrl;
    } //-- void setOverrideLocalStorageUrl( String )

    /**
     * Set the remote storage details.
     * 
     * @param remoteStorage
     */
    public void setRemoteStorage( RepositoryResourceRemoteStorage remoteStorage )
    {
        this.remoteStorage = remoteStorage;
    } //-- void setRemoteStorage( RepositoryResourceRemoteStorage )

    /**
     * Set the repository policy (release, snapshot).
     * 
     * @param repoPolicy
     */
    public void setRepoPolicy( String repoPolicy )
    {
        this.repoPolicy = repoPolicy;
    } //-- void setRepoPolicy( String )

    /**
     * Set write policy on the repository, allows for no write,
     * write once, overwrite, etc.
     * 
     * @param writePolicy
     */
    public void setWritePolicy( String writePolicy )
    {
        this.writePolicy = writePolicy;
    } //-- void setWritePolicy( String )

}
